SystemOrganization addCategory: #'AL-Core-Kernel'!
SystemOrganization addCategory: #'AL-Core-Exceptions'!
SystemOrganization addCategory: #'AL-Core-Utilities'!

Exception subclass: #ALException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Exceptions'!

ALException subclass: #ALError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Exceptions'!

!ALError methodsFor: 'as yet unclassified' stamp: 'cwp 9/11/2008 23:00'!
defaultAction
	UnhandledError signalForException: self! !

!ALError methodsFor: 'as yet unclassified' stamp: 'cwp 9/11/2008 23:00'!
isResumable 
	^ false! !

ALError subclass: #ALNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Exceptions'!

!ALNotFound methodsFor: 'as yet unclassified' stamp: 'cwp 9/11/2008 23:01'!
handleWith: anObject
	^ anObject handleNotFound: self! !

Object subclass: #ALApplication
	instanceVariableNames: 'locator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Kernel'!

!ALApplication class methodsFor: 'as yet unclassified' stamp: 'cwp 3/7/2011 23:08'!
withLocator: aLocator
	^ self basicNew
		initializeWithLocator: aLocator;
		yourself! !

!ALApplication methodsFor: 'error handling' stamp: 'cwp 4/23/2011 18:44'!
handleNotFound: anError
	^ ALResponse notFound: anError messageText! !

!ALApplication methodsFor: 'api' stamp: 'cwp 4/23/2011 17:29'!
handleRequest: aRequest
	| path |
	path := aRequest path.
	^ [(locator resourceForPath: path) handleRequest: aRequest locator: locator]
		on: ALError
		do: [:err | err handleWith: self]
! !

!ALApplication methodsFor: 'initialize-release' stamp: 'cwp 3/7/2011 23:08'!
initializeWithLocator: aLocator
	locator := aLocator! !

Object subclass: #ALDirectoryScanner
	instanceVariableNames: 'locator guide ignore root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Utilities'!

!ALDirectoryScanner class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:34'!
locator: aLocator
	^ self basicNew initializeWithLocator: aLocator  ! !

!ALDirectoryScanner class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:46'!
scan: aReference into: aLocator
	(self locator: aLocator) scan: aReference.
	^ aLocator! !

!ALDirectoryScanner methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:37'!
initializeWithLocator: aLocator
	locator := aLocator.
	guide := FSPreorderGuide for: self.! !

!ALDirectoryScanner methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:54'!
scan: aReference
	root := aReference resolve.
	guide show: root! !

!ALDirectoryScanner methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:53'!
visitDirectory: anEntry
	| reference |
	reference := anEntry reference.
	(reference basename first = $.) ifTrue: [ignore := reference].
	! !

!ALDirectoryScanner methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2011 00:00'!
visitFile: anEntry
	| path reference |
	reference := anEntry reference.
	ignore ifNotNil: [(ignore contains: reference) ifTrue: [^ self]].
	ignore := nil.
	(reference basename first = $.) ifFalse:
		[path := ALPath withAll: (reference relativeTo: root).
		locator at: path put: (ALFileResource on: reference)]! !

Object subclass: #ALLocator
	instanceVariableNames: 'hash map paths resources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Kernel'!

!ALLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 22:25'!
forTesting
	^ self
		hash: [:obj | #[1 2 3]]
		map: [:obj | ALPath / 'obj'].! !

!ALLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 21:41'!
hash: hashBlock map: mapBlock
	^ self basicNew initializeWithHash: hashBlock map: mapBlock ! !

!ALLocator class methodsFor: 'as yet unclassified' stamp: 'cwp 8/20/2011 22:57'!
withDigests
	^ self 
		hash: [ :r | r serialize digest ] 
		map: [ :r | ALPath with: r serialize digest ] ! !

!ALLocator methodsFor: 'public' stamp: 'cwp 8/16/2011 22:54'!
at: aPath alias: aResource
	"Register a resource to be available from a non-canonical path"
	
	resources at: aPath put: aResource.! !

!ALLocator methodsFor: 'public' stamp: 'cwp 8/16/2011 22:37'!
at: aPath put: aResource
	resources at: aPath put: aResource.
	paths at: (hash value: aResource) put: aPath
! !

!ALLocator methodsFor: 'initialize-release' stamp: 'cwp 8/16/2011 21:56'!
initializeWithHash: hashBlock map: mapBlock
	hash := hashBlock.
	map := mapBlock.
	paths := Dictionary new.
	resources := Dictionary new.! !

!ALLocator methodsFor: 'public' stamp: 'cwp 8/16/2011 22:18'!
pathForResource: aResource
	^ paths
		at: (hash value: aResource)
		ifAbsentPut: 
			[| path |
			path := map value: aResource.
			resources at: path put: aResource.
			path]  ! !

!ALLocator methodsFor: 'public' stamp: 'cwp 8/16/2011 22:31'!
resourceForPath: aPath
	^ resources 
		at: aPath 
		ifAbsent: [ALNotFound signal: aPath printString]
		
			! !

!ALLocator methodsFor: 'serializing' stamp: 'cwp 8/6/2011 19:13'!
serializeWith: aSerializer
	aSerializer serializeExternal: self  ! !

Object variableSubclass: #ALPath
	instanceVariableNames: ''
	classVariableNames: 'Slash'
	poolDictionaries: ''
	category: 'AL-Core-Kernel'!

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 3/20/2011 22:57'!
/ aString
	^ self with: aString! !

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2011 16:16'!
initialize
	Slash := '/'! !

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 14:31'!
root
	^ self new: 0! !

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 14:48'!
with: aString
	^ (self new: 1)
		at: 1 put: aString;
		yourself! !

!ALPath class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:58'!
withAll: segments
	| path |
	path := self new: segments size.
	1 to: path size do: [:index | path at: index put: (segments at: index)].
	^ path! !

!ALPath methodsFor: 'as yet unclassified' stamp: 'cwp 9/11/2011 15:13'!
/ aString
	| path |
	path := self class new: self size + 1.
	1 to: self size do: [:i | path at: i put: (self at: i)].
	path at: (path size) put: aString.
	^ path! !

!ALPath methodsFor: 'as yet unclassified' stamp: 'cwp 3/21/2011 22:20'!
= other
	self species = other species ifFalse: [^ false].
	self size = other size ifFalse: [^ false].
	1 to: self size do: [:i | (self at: i) = (other at: i) ifFalse: [^ false]].
	^ true! !

!ALPath methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 15:17'!
first
	^ self at: 1! !

!ALPath methodsFor: 'as yet unclassified' stamp: 'cwp 3/21/2011 22:22'!
hash
	| hash |
	hash := self class hash.
	1 to: self size do: [:i | hash := hash bitXor: (self at: i) hash].
	^ hash! !

!ALPath methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 14:54'!
isRoot
	^ self size = 0! !

!ALPath methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2011 22:16'!
printOn: aStream
	| ws |
	ws := String new writing.
	self streamingPrintOn: ws.  
	aStream nextPutAll: ws conclusion.! !

!ALPath methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 15:18'!
rest
	| rest |
	rest := self class new: self size - 1.
	1 to: rest size do: [:index | rest at: index put: (self at: index + 1)].
	^ rest! !

!ALPath methodsFor: 'as yet unclassified' stamp: 'cwp 9/6/2011 16:15'!
streamingPrintOn: aWriteStream
	self isRoot 
		ifTrue: [aWriteStream write: Slash]
		ifFalse:
			[1 to: self size do:
				[:index |
				aWriteStream write: Slash.
				aWriteStream write: (self at: index)]]! !

Object subclass: #ALResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Kernel'!

ALResource subclass: #ALCallbackResource
	instanceVariableNames: 'resource callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Kernel'!

!ALCallbackResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2011 22:19'!
resource: aResource callback: aValuable
	^ self basicNew initializeWithResource: aResource callback: aValuable! !

!ALCallbackResource methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2011 22:30'!
applyRequest: aRequest
	^ self value! !

!ALCallbackResource methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2011 22:20'!
initializeWithResource: aResource callback: aValuable
	self initialize.
	resource := aResource.
	callback := aValuable.! !

!ALCallbackResource methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2011 22:30'!
value
	callback value.
	^ resource! !

ALResource subclass: #ALDataResource
	instanceVariableNames: 'facet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Core-Kernel'!

!ALDataResource class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2011 11:36'!
facet: aFacet
	^ self basicNew initializeWithFacet: aFacet! !

!ALDataResource methodsFor: 'public' stamp: 'cwp 8/5/2011 22:10'!
handleRequest: aRequest locator: aLocator
	
	^ ALResponse 
		type: 'application/json'
		callback: 
			[:out || utf8 context |
			utf8 := out encoding: #utf8.
			context := (ALRenderingContext resource: self locator: aLocator).
			facet renderOn: (ALJsonRenderer context: context stream: utf8)]
	! !

!ALDataResource methodsFor: 'initialize-release' stamp: 'cwp 7/21/2011 11:36'!
initializeWithFacet: aFacet
	facet := aFacet! !

ALResource subclass: #ALFileResource
	instanceVariableNames: 'reference'
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'AL-Core-Kernel'!

!ALFileResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/22/2011 22:03'!
initialize
	MimeTypes := Dictionary new
		at: 'css' put: 'text/css';
		at: 'html' put: 'text/html';
		at: 'ico' put: 'image/vnd.microsoft.icon';
		at: 'js' put: 'application/javascript';
		at: 'less' put: 'text/x-lesscss';
		at: 'png' put: 'image/png';
		yourself.! !

!ALFileResource class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 23:17'!
on: aReference
	^ self new initializeWithReference: aReference! !

!ALFileResource methodsFor: 'comparing' stamp: 'cwp 3/11/2011 23:18'!
= other 
	^ self species = other species and: [self reference = other reference]! !

!ALFileResource methodsFor: 'public' stamp: 'cwp 8/22/2011 22:19'!
contentType
	^ MimeTypes 
		at: reference extension
		ifAbsent: ['application/octet-stream']! !

!ALFileResource methodsFor: 'public' stamp: 'cwp 8/16/2011 16:00'!
handleRequest: aRequest locator: aLocator
	| body |
	body := ALEntity callback: [ :out | out write: reference reading].
	body contentType: self contentType.
	body contentLength: reference resolve entry size.
	^ ALResponse status: 200 reason: 'OK' body: body! !

!ALFileResource methodsFor: 'comparing' stamp: 'cwp 3/11/2011 23:18'!
hash
	^ reference hash! !

!ALFileResource methodsFor: 'initialize-release' stamp: 'cwp 3/11/2011 23:18'!
initializeWithReference: aReference
	reference := aReference ! !

!ALFileResource methodsFor: 'accessing' stamp: 'cwp 3/11/2011 23:18'!
reference
	^ reference! !

!ALResource methodsFor: 'public' stamp: 'cwp 8/9/2011 16:00'!
handleRequest: aRequest locator: aLocator
	| path |
	path := aLocator pathForResource: (self applyRequest: aRequest).
	^ ALResponse seeOther: path! !
ALPath initialize!
ALFileResource initialize!
